blog/config/routes.rb
Rails.application.routes.draw do
  get 'welcome/index'
  root 'welcome#index'

  devise_for :users, :controllers => { registrations: 'registrations' }
  resources :devise

  resources :users, except: [:show, :destroy] do
    resources :items
  end

  resources :lists do
    resources :items
  end

  resources :items do
    member do
      patch :finish
      put :finish
    end
  end

end

blog/app/models/list.rb
class List < ApplicationRecord
  belongs_to :user
  has_many :items, dependent: :destroy
  has_and_belongs_to_many :participants, class_name: "User", join_table: "lists_users"

  validates :list_name, presence: true, uniqueness: { scope: :user_id,
    message: "duplicate !!" }, on: :create

  def self.search(search)
    if search
      where('lists.list_name LIKE ?', "%#{search}%")
    else
      all
    end
  end
end

blog/app/controllers/lists_controller.rb
class ListsController < ApplicationController
  before_action :load_list_update, only: [:edit, :update, :destroy]
  before_action :load_list_create, only: [:new, :create]

  def index
    @lists = List.where("lists.user_id = ?",current_user.id).order(created_at: :desc).paginate(:page => params[:page], :per_page => 3).search(params[:search])
  end


  def create
    @list = List.new(list_params)
    @list.user_id = current_user.id

    if @list.save
      redirect_to lists_path, notice: "List was successfully created."
    else
      render 'new', alert: "ERROR!"
    end
  end

  def update
    if @list.update list_params
      redirect_to lists_path, notice: "List was successfully updated."
    else
      render 'edit', alert: "ERROR!"
    end
  end

  def destroy
    @list.destroy
    redirect_to lists_path, notice: "List was destroyed."
  end

private

  def load_list_update
    @list = List.find(params[:id])
  end

  def load_list_create
    @list = List.where(:user_id => current_user.id).new
  end

  def list_params
    params.require(:list).permit(:list_name, :user_id, { participant_ids:[] })
  end

end

blog/app/helpers/lists_helper.rb
module ListsHelper
end

blog/app/views/lists/_form.html.erb
<div class="login-form-1">
  <%= form_with model: @list, html: {class: 'text-left'} do |f| %>
  <% if @list.errors.any? %>
  <div class="login-form-main-message">
    <h2>
      <%= pluralize(@list.errors.count, "error") %> prohibited
      this list from being saved:
    </h2>
    <ul>
      <% @list.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
    </ul>
  </div>
  <% end %>

  <div class="main-login-form">
    <div class="login-group">

      <div class="form-group">
        <%= f.text_field :list_name, class: "form-control", required: true, placeholder: "List name" %>
      </div>

      <div class="form-group">
        <%= f.label :participants, class: "par-label" %><br />
        <% User.where("id != ?",current_user.id).each do |user| %>
          <%= check_box_tag "list[participant_ids][]", user.id, @list.participant_ids.include?(user.id) %> <%= user.full_name %> <br>
        <% end %>
      </div>

      <button type="submit" class="login-button"><i class="fa fa-chevron-right"></i></button>
    </div>
    <button type="button" class="btn btn-light create"><%= link_to 'Back to My Lists', lists_path %></button>
  </div>
  <% end %>
</div>

blog/app/views/lists/edit.html.erb
<div class="container">
<!-- col-12 col-md-6 offset-md-3 header -->
  <div class ="row">
    <div class="col-12 text-center" id="text-center">
      <div class="logo">UPDATE LIST</div>
      <%= render 'form' %>
    </div>
  </div>
</div>

blog/app/views/lists/index.html.erb
<div class="container-fluid">
<!-- Breadcrumbs-->
<ol class="breadcrumb">
  <li class="breadcrumb-item">
    <a href="#">My Lists</a>
  </li>
  <li class="breadcrumb-item active">All Lists</li>
</ol>
<div class="row">
  <div class="col-2">
    <button type="button" class="btn btn-danger create"><%= link_to "Create new list", new_list_path %></button>
  </div>
</div>
<div class="row mt-2">
<% @lists.each do |list| %>
  <div class="col-xl-4 col-sm-6 mb-3 col-12">
    <div class="card mb-3">
      <div class="card-body c-title">
        <h6 class="card-title mb-1">List name | <%= link_to list.list_name, list_items_path(list)%></h6>
      </div>
      <hr class="my-0">
      <div class="hvrbox">
        <div class="card-body py-2">
            <p class="card-text">Total items = <%= list.items.size %></p>
            <p class="card-text">Participations:<%= list.participants.size %>
            <% if list.participants.size > 0 %>
            <br /><i class="fa fa-fw fa-user color-all-text"></i>
            <% else %>
            <% end %>
            <%= list.participants.map { |i| i.full_name.to_s }.join(", ") %>
            </p>
          <div class="hvrbox-layer_top hvrbox-layer_scale">
            <div class="hvrbox-text">
              <a href="<%= edit_list_path(list.id) %>" class="option"><i class="fas fa-edit"></i> Edit list</a><br />
              <a data-confirm="Are you sure?" class="option" rel="nofollow" data-method="delete" href="<%= list_path(list.id) %>"><i class="fas fa-trash-alt"></i> Delete list</a><br />
            </div>
          </div>
        </div>
      </div>
      <div class="card-footer small text-muted">Created at <%= list.created_at.strftime("%b %d, %Y") %></div>
    </div>
  </div>
<% end %>
</div>
<%= will_paginate @lists %>
</div>

blog/app/views/lists/new.html.erb
<div class="container">
<!-- col-12 col-md-6 offset-md-3 header -->
  <div class ="row">
    <div class="col-12 text-center" id="text-center">
      <div class="logo">CREATE LIST</div>
      <%= render 'form' %>
    </div>
  </div>
</div>